Scriptname PD_AmpManager extends Quest

PD_Util Property Util Auto

Faction[] Property AmpFactions Auto Hidden
Bool Property AmputatorPresent Auto Hidden
Float[] Property Chances Auto Hidden
Int[] Property MaxLevels Auto Hidden

Int Property MaxLimbs = 4 Auto Hidden

Quest AmpQuest

Event OnInit()
    RegisterForSingleUpdate(1.0)
EndEvent

Event OnUpdate()
    Chances = new Float[4]
    Chances[0] = 0.0
    Chances[1] = 0.5
    Chances[2] = 0.0
    Chances[3] = 0.5

    MaxLevels = new Int[4]
    MaxLevels[0] = 2
    MaxLevels[1] = 3
    MaxLevels[2] = 2
    MaxLevels[3] = 3

    Initialize()
EndEvent

Function Initialize()
    AmputatorPresent = Game.GetModByName("Amputator.esm") != 255
    if AmputatorPresent
        AmpQuest = Quest.GetQuest("_AMP_MainQuest")

        AmpFactions = new Faction[4]
        AmpFactions[0] = Game.GetFormFromFile(0x0300BF76, "Amputator.esm") as Faction ; left left
        AmpFactions[1] = Game.GetFormFromFile(0x0300BF77, "Amputator.esm") as Faction ; left arm
        AmpFactions[2] = Game.GetFormFromFile(0x0300BF78, "Amputator.esm") as Faction ; right leg
        AmpFactions[3] = Game.GetFormFromFile(0x0300BF79, "Amputator.esm") as Faction ; right arm
        Util.LogInfo("AmpManager initialized")
    endIf
EndFunction

Bool Function AmpLimbExists(Actor akTarget)
    int i = 0

    while i < AmpFactions.Length
        Util.LogInfo("Checking " + i + " " + Chances[i] + " " + akTarget.GetFactionRank(AmpFactions[i]) + " " + MaxLevels[i])


        if Chances[i] > 0.0 && akTarget.GetFactionRank(AmpFactions[i]) < MaxLevels[i]
            return true
        endIf

        i += 1
    endWhile

    return false
EndFunction

Function AmputateActor(Actor akTarget)
    int i = 0
    int amputated = 0
    int highestLimb = -1
    while i < AmpFactions.Length
        Util.LogInfo("Checking limb " + i + " " + Chances[i] + " " + akTarget.GetFactionRank(AmpFactions[i]) + " " + MaxLevels[i])
        if amputated >= MaxLimbs
            i = AmpFactions.Length
        endIf

        if akTarget.GetFactionRank(AmpFactions[i]) < MaxLevels[i]

            if Utility.RandomFloat(0, 1.0) <= Chances[i]
                Amputate(akTarget, i)
                amputated += 1
            endIf

            if highestLimb < 0 || Chances[i] > Chances[highestLimb]
                highestLimb = i
            endIf
        endIf

        i += 1
    endWhile

    if amputated == 0 && highestLimb > -1
        Amputate(akTarget, highestLimb)
    endIf
EndFunction

Function Amputate(Actor akTarget, int i)
    Util.LogInfo("Amputating " + i + " on " + akTarget)

    int morphType = akTarget.GetFactionRank(AmpFactions[i])
    
    if morphType < 0
        morphType = 0
    endIf
    Util.LogInfo("Before 1" + morphType)

    if i == 1 || i == 3
        morphType += 3
    endIf
    Util.LogInfo("Before 2" + morphType)

    morphType += 1

    int bothleftright = 1
    if i > 1
        bothleftright = 2
    endIf

    Util.LogInfo("Applying amputation mt=" + morphType + " blr=" + bothleftright)

    (AmpQuest as _AMP_Main).ApplyAmputator(akTarget, morphType, bothleftright)
EndFunction

String Function GetIndexLimb(int i)
    if i == 0
        return "Left Leg"
    elseIf i == 1
        return "Left Arm"
    elseIf i == 2
        return "Right Leg"
    else
        return "Right Arm"
    endIf
EndFunction