Scriptname PD_Amputation extends PD_EventTemplate

PD_AmpManager Property AManager Auto
Scene Property AmpScene Auto
Actor Property PlayerRef Auto

Sound Property YellSound Auto
Sound Property SlashSound Auto

Quest Property RescueQuest Auto
Quest Property L4DQuest Auto

PD_Rescue Property RescueEvent Auto
PD_LeftForDead Property L4DEvent Auto

Bool Function IsValid()
    return AManager.AmputatorPresent
EndFunction

Bool Function CanSelectRelease(Actor[] victims, int male, int female)
    bool canSelect = AManager.AmpLimbExists(PlayerRef)
    return canSelect
EndFunction

Bool Function Start()
    AmpScene.Start()
    return true
EndFunction

Function AmputateActor()
    BlackFade()
    Utility.Wait(2.0)

    SlashSound.PlayAndWait(PlayerRef)
    AManager.AmputateActor(PlayerRef)

    Quest outcomeQuest

    if L4DEvent.Weight == 0
        outcomeQuest = RescueQuest
    elseIf RescueEvent.Weight == 0
        outcomeQuest = L4DQuest
    else
        int combinedWeight = L4DEvent.Weight + RescueEvent.Weight
        int val = Utility.RandomInt(0, combinedWeight)
        if val > L4DEvent.Weight
            outcomeQuest = RescueQuest
        else
            outcomeQuest = L4DQuest
        endif
    endIf

    string baseMsg
    if outcomeQuest == RescueQuest
        baseMsg = "The blood loss causes you to pass out almost immediately as their laughs fade into silence. Luckily, someone brings you to a nearby inn and stitches up your wounds."
    else
        baseMsg = "You stumble away as they laugh and barely manage to tie off the stump before passing out."
    endIf

    Debug.MessageBox(baseMsg)

    bool result = outcomeQuest.Start()

    if !result
        RemoveBlackFade()
    endIf

    Utility.Wait(2.0)
    FinishEvent()
EndFunction