Scriptname PD_EventTemplateSex extends PD_EventTemplate  

Scene Property SexScene Auto
ReferenceAlias Property Speaker Auto

Int Property NumAggs Auto

sslBaseAnimation[] t1_anims
sslBaseAnimation[] t2_anims
sslBaseAnimation[] t3_anims
sslBaseAnimation[] t4_anims

Actor[] t1_pos
Actor[] t2_pos
Actor[] t3_pos
Actor[] t4_pos

Actor[] sexVics
Actor[] tempVics
Int[] tids

Actor PlayerAggressor
Int PlayerIndex
int genderOptions

int index = 0
int activeScenes = 0
int tempScenes = 0
int maxThreads = 4

bool reset

Function OnModuleInit()
    sexVics = PapyrusUtil.ActorArray(maxThreads)
    tids = PapyrusUtil.IntArray(12)
EndFunction

Bool Function CanSelect(int victimGender, int male, int female)
    Util.LogInfo("Male = " + Male + " Female = " + female)
    genderOptions = Util.CanCreateScene(victimGender, male, female, NumAggs)
    Util.LogInfo("Gender Options " + EventName + " :" + genderOptions)
    return genderOptions > 0
EndFunction

Actor[] Function Select(int victimIndex, Actor[] victims, Actor[] aggressors)
    reset = false

    Actor victim = victims[victimIndex]
    Actor[] selectedAggs = Util.GetValidAggressors(aggressors, NumAggs, genderOptions)

    Actor[] positions = new Actor[1]
    positions[0] = victim
    positions = PapyrusUtil.MergeActorArray(positions, selectedAggs)
    SetPosArray(index, positions)
    SetAnimArray(index, Util.GetAnimations(positions.length, victim, positions[1]))
    
    sexVics[index] = victim
    
    index += 1
    
    return selectedAggs
EndFunction

Bool Function Start()
    if index > 0
        index -= 1
        return StartSex(sexVics[index] == Game.GetPlayer())
    else
        return false
    endIf
EndFunction

Bool Function StartSex(bool player = false)
    Actor[] positions = GetPosArray(index)
    sslBaseAnimation[] anims = GetAnimArray(index)
    string hookName = "PD_" + positions.length + "PSexScene" + index

    int tid = Util.StartSexWithAnimations(positions, positions[0], anims, hookName)
   
    if tid >= 0
        tids[tid] = index
        RegisterForModEvent("HookAnimationEnd_" + hookName, "On" + positions.length + "PSexSceneEnded")
        activeScenes += 1
    elseIf index == 0 && activeScenes == 0
        FinishEvent()
    endIf

    return tid >= 0
EndFunction

Function Reset()
    if !reset
        tempVics = PapyrusUtil.ActorArray(maxThreads)
        int i = 0
        while i < sexVics.length
            Actor[] posArray = GetPosArray(i)

            if posArray
                tempVics[i] = posArray[0]
            endIf

            i += 1
        endWhile
        reset = true
    endIf

    tempScenes = activeScenes

    index = 0
    activeScenes = 0
    sexVics = PapyrusUtil.ActorArray(maxThreads)
EndFunction

Function OnSceneEnded(int tid, bool HasPlayer)
    tempScenes -= 1
    RM.RestrainActor(tempVics[tids[tid]], true)

    if tempScenes <= 0
        FinishEvent()
    endIf
EndFunction

sslBaseAnimation[] Function GetAnimArray(int ind)
    if ind == 0
        return t1_anims
    elseIf ind == 1
        return t2_anims
    elseIf ind == 2
        return t3_anims
    elseIf ind == 3
        return t4_anims
    endIf
EndFunction

Function SetAnimArray(int ind, sslBaseAnimation[] anims)
    if ind == 0
        t1_anims = anims
    elseIf ind == 1
        t2_anims = anims
    elseIf ind == 2
        t3_anims = anims
    elseIf ind == 3
        t4_anims = anims
    endIf
EndFunction

Actor[] Function GetPosArray(int ind)
    if ind == 0
        return t1_pos
    elseIf ind == 1
        return t2_pos
    elseIf ind == 2
        return t3_pos
    elseIf ind == 3
        return t4_pos
    endIf
EndFunction

Function SetPosArray(int ind, Actor[] pos)
    if ind == 0
        t1_pos = pos
    elseIf ind == 1
        t2_pos = pos
    elseIf ind == 2
        t3_pos = pos
    elseIf ind == 3
        t4_pos = pos
    endIf
EndFunction