Scriptname PD_FSM extends PD_EventTemplate

PD_FollowerManager Property FM Auto
Scene Property FSMScene Auto
Actor Property PlayerRef Auto

Sound Property HitSound Auto

Quest Property RescueQuest Auto
Quest Property L4DQuest Auto

PD_Rescue Property RescueEvent Auto
PD_LeftForDead Property L4DEvent Auto

Actor Master
Actor Slave

Bool Function IsValid()
    return FM.FSMPresent
EndFunction

Bool Function CanSelectRelease(Actor[] victims, int male, int female)
    if victims.length < 2
        return false
    endIf

    int i = 1
    while i < victims.length
        if FM.CanEnslave(victims[i])
            Slave = victims[i]
            return true
        endIf
        i += 1
    endWhile

    return false
EndFunction

Actor[] Function Select(int victimIndex, Actor[] victims, Actor[] aggressors)
    Master = aggressors[Utility.RandomInt(0, aggressors.length - 1)]
EndFunction

Bool Function Start()
    FSMScene.Start()
    return true
EndFunction

Function EnslaveFollower()
    BlackFade()
    bool enslaved = FM.EnslaveFollower(Slave, Master, true)
    Util.LogInfo("Follower was enslaved = " + enslaved)

    Utility.Wait(2.0)

    HitSound.PlayAndWait(PlayerRef)

    Quest outcomeQuest

    if L4DEvent.Weight == 0
        outcomeQuest = RescueQuest
    elseIf RescueEvent.Weight == 0
        outcomeQuest = L4DQuest
    else
        int combinedWeight = L4DEvent.Weight + RescueEvent.Weight
    endIf

    string baseMsg
    if outcomeQuest == RescueQuest
        baseMsg = "Before you can respond, they knock you out. Luckily, someone brings you to a nearby inn and stitches up your wounds. Your follower isn't so lucky."
    else
        baseMsg = "Before you can respond, they knock you out. You need to find your follower or leave them to their fate."
    endIf

    Debug.MessageBox(baseMsg)

    bool result = outcomeQuest.Start()

    if !result
        RemoveBlackFade()
    endIf

    FinishEvent()


EndFunction