Scriptname PD_LeftForDeadQuest extends Quest  

Import po3_SKSEFunctions

Actor Property PlayerRef  Auto  
FormList Property InteriorMarkerList  Auto  
PD_Util Property Util  Auto  
PD_DefeatHandler Property DH  Auto  

Function MoveToSafeSpot()
    PlayerRef.RestoreActorValue("health", 20)
    
    cell currCell = playerref.GetParentCell()

    if currCell.isinterior()
        location currLocation = playerref.GetCurrentLocation()
        ObjectReference marker = Game.FindClosestReferenceOfAnyTypeInListFromRef(InteriorMarkerList, PlayerRef, 50000.0)
        bool exit = false
        while (marker.IsInInterior() || marker == none) && !exit
            currLocation = GetParentLocation(currLocation)
            if currLocation
                marker = Game.FindClosestReferenceOfAnyTypeInListFromRef(InteriorMarkerList, PlayerRef, 50000.0)
            else 
                exit = true
            endif 
        endwhile 

        if marker 
            PlayerRef.moveto(marker)
        endif 
    endif  
    
    cell[] cells = GetAttachedCells()

    cell TargetCell

    int i = 0
    int l = cells.Length
    while i < l 
        location loc = CellToLocation(cells[i])

        if loc == none 
            TargetCell = cells[i]
            l = cells.Length
        endif 
         
        i += 1
    endwhile

    if !TargetCell
        targetcell = cells[Utility.randomint(0, cells.Length - 1)]
    endif 

    playerref.MoveTo(TargetCell.GetNthRef(0))
    MoveToNearestNavmeshLocation(PlayerRef)
    
    if DH.Victims.Length > 1
        i = 1
        while i < DH.Victims.Length
            DH.Victims[i].MoveTo(PlayerRef, Utility.RandomFloat(-512, 512), Utility.RandomFloat(-512, 512), abMatchRotation = false)
            MoveToNearestNavmeshLocation(DH.Victims[i])

            DH.Victims[i].PushActorAway(DH.Victims[i], 0.1)
            i += 1
        EndWhile
    endif 


    Game.DisablePlayerControls(ablooking = true, abCamSwitch = true)
    Game.ForceFirstPerson()

    Util.WakeupWoozy()

    Utility.Wait(3)

    Game.EnablePlayerControls()
    
    debug.Notification("You were dumped nearby")    
EndFunction

Location Function CellToLocation(cell c)
    return c.GetNthRef(0).GetCurrentLocation()
EndFunction
