Scriptname PD_RestraintsManager extends Quest  

PD_Util Property Util Auto

Bool Property DDPresent Auto Hidden

Form[] Property ArmRestraints Auto Hidden
Form[] Property Gags Auto Hidden
Form[] Property Blindfolds Auto Hidden
Form[] Property LegRestraints Auto Hidden
Form[] Property Hoods Auto Hidden
Form[] Property APlugs Auto Hidden
Form[] Property VPlugs Auto Hidden
Form[] Property Collars Auto Hidden
Form[] Property Misc Auto Hidden


Float Property ArmRestraintsChance = 1.0 Auto Hidden
Float Property GagsChance = 1.0 Auto Hidden
Float Property BlindfoldsChance = 0.2 Auto Hidden
Float Property LegRestraintsChance = 0.2 Auto Hidden
Float Property HoodsChance = 0.2 Auto Hidden
Float Property APlugsChance = 0.5 Auto Hidden
Float Property VPlugsChance = 0.5 Auto Hidden
Float Property CollarsChance = 0.5 Auto Hidden
Float Property MiscChance = 0.5 Auto Hidden

Int Property MaxRestraints = 10 Auto Hidden

Bool Property MaleFollowerRestraintsEnabled = true Auto Hidden
Bool Property FemaleFollowerRestraintsEnabled = true Auto Hidden

Float Property TightenChance = 0.2 Auto Hidden
Float Property JamChance = 0.2 Auto Hidden

Armor Property Cuffs Auto
Armor Property Fetters Auto

Actor Property PlayerRef Auto

Quest DD_Quest

Keyword[] HeavyBondageKeywords
Keyword[] WriArmbinderKeywords 
Keyword[] YokeKeywords
Keyword[] LegCuffsKeywords

Int[] DDSlots

Keyword[] Property KeyKeywords Auto Hidden
Keyword LockableKeyword

Key[] Keys

Bool ProcessedDD = false

Faction Property BindTypeFaction Auto
Faction Property LegRestraintsFaction Auto
Faction Property TrackedFaction Auto

String[] ArmWriHogtiePoses
String[] YokeHogtiePoses

String[] WoundedPoses
String[] ArmWriWoundedPoses
String[] YokeWoundedPoses


Bool Property DDePresent = false Auto Hidden
Bool Property UseDDe = false Auto Hidden
String[] Property DDeOutfits Auto Hidden

Event OnInit()
    RegisterForSingleUpdate(3.0)
EndEvent

Event OnUpdate()
    Initialize()
EndEvent

Function Initialize()
    Util.LogInfo("Initializing RM")
    
    ArmWriHogtiePoses = new String[4]
    ArmWriHogtiePoses[0] = "PD_WriPose11"
    ArmWriHogtiePoses[1] = "PD_WriPose13"
    ArmWriHogtiePoses[2] = "PD_WriStruggle11"
    ArmWriHogtiePoses[3] = "PD_WriStruggle13"

    YokeHogtiePoses = new String[4]
    YokeHogtiePoses[0] = "PD_YokePose11"
    YokeHogtiePoses[1] = "PD_YokePose13"
    YokeHogtiePoses[2] = "PD_YokeStruggle11"
    YokeHogtiePoses[3] = "PD_YokeStruggle13"

    WoundedPoses = new String[3]
    WoundedPoses[0] = "IdleWounded_01"
    WoundedPoses[1] = "IdleWounded_02"
    WoundedPoses[2] = "IdleWounded_03"

    ArmWriWoundedPoses = new String[4]
    ArmWriWoundedPoses[0] = "PD_WriPose14"
    ArmWriWoundedPoses[1] = "PD_WriStruggle14"
    ArmWriWoundedPoses[2] = "PD_WriPose15"
    ArmWriWoundedPoses[3] = "PD_WriStruggle15"

    YokeWoundedPoses = new String[2]
    YokeWoundedPoses[0] = "PD_YokePose15"
    YokeWoundedPoses[1] = "PD_YokeStruggle15"
    LoadRestraints()

    Util.LogInfo("Finished initializing RM")
EndFunction

Function LoadRestraints()
    DDPresent = Game.GetModByName("Devious Devices - Assets.esm") != 255 && Game.GetModByName("Devious Devices - Integration.esm") != 255 && Game.GetModByName("Devious Devices - Expansion.esm") != 255
    DDePresent = Game.GetModByName("Devious Devices - Equip.esp") != 255

    if DDPresent 
        HeavyBondageKeywords = new Keyword[1]
        YokeKeywords = new Keyword[2]
        WriArmbinderKeywords = new Keyword[5]
        LegCuffsKeywords = new Keyword[2]
        Keys = new Key[3]
        KeyKeywords = new Keyword[1]
        DDSlots = new Int[18]
        DDSlots[0] = 59
        DDSlots[1] = 44
        DDSlots[2] = 58
        DDSlots[3] = 45
        DDSlots[4] = 32
        DDSlots[5] = 46
        DDSlots[6] = 48
        DDSlots[7] = 49
        DDSlots[8] = 50
        DDSlots[9] = 51
        DDSlots[10] = 53
        DDSlots[11] = 55
        DDSlots[12] = 56
        DDSlots[13] = 57
        DDSlots[14] = 32
        DDSlots[15] = 33
        DDSlots[16] = 30
        DDSlots[17] = 37

        LockableKeyword = Keyword.GetKeyword("zad_Lockable")
    endIf
    
    if DDPresent
        DD_Quest = (Game.GetFormFromFile(0x00F624, "Devious Devices - Integration.esm") as Quest)
        string fileName = "../Practical Defeat/Devious Devices"
        ArmRestraints = JsonUtil.FormListToArray(fileName, "arms")
        LegRestraints = JsonUtil.FormListToArray(fileName, "legs")
        Gags = JsonUtil.FormListToArray(fileName, "gag")
        Blindfolds = JsonUtil.FormListToArray(fileName, "blindfold")
        Hoods = JsonUtil.FormListToArray(fileName, "hood")
        APlugs = JsonUtil.FormListToArray(fileName, "anal-plug")
        VPlugs = JsonUtil.FormListToArray(fileName, "vaginal-plug")
        Collars = JsonUtil.FormListToArray(fileName, "collar")
        Misc = JsonUtil.FormListToArray(fileName, "misc")
        
        HeavyBondageKeywords[0] = Keyword.GetKeyword("zad_DeviousHeavyBondage")

        YokeKeywords[0] = Keyword.GetKeyword("zad_DeviousYoke")
        YokeKeywords[1] = Keyword.GetKeyword("zad_DeviousYokeBB")
    
        WriArmbinderKeywords[0] = Keyword.GetKeyword("zad_DeviousCuffsFront")
        WriArmbinderKeywords[1] = Keyword.GetKeyword("zad_DeviousArmbinderElbow")
        WriArmbinderKeywords[2] = Keyword.GetKeyword("zad_DeviousArmbinder")
        WriArmbinderKeywords[3] = Keyword.GetKeyword("zad_DeviousStraitJacket")
        WriArmbinderKeywords[4] = Keyword.GetKeyword("zad_DeviousElbowTie")

        LegCuffsKeywords[0] = Keyword.GetKeyword("zad_DeviousLegCuffs")
        LegCuffsKeywords[1] = Keyword.GetKeyword("zad_DeviousAnkleShackles")
        
        KeyKeywords[0] = Keyword.GetKeyword("zad_NonUniqueKey")

        Keys[0] = Game.GetFormFromFile(0x0501775F, "Devious Devices - Integration.esm") as Key ; restraints
        Keys[1] = Game.GetFormFromFile(0x050409A4, "Devious Devices - Integration.esm") as Key ; piercings
        Keys[2] = Game.GetFormFromFile(0x05008A4F, "Devious Devices - Integration.esm") as Key ; chastity
        ProcessedDD = true
    endIf

    if DDePresent
        if DDeOutfits.Length == 0
            DDeOutfits = Utility.CreateStringArray(10, "")
            DDeOutfits[0] = "inox"
            DDeOutfits[1] = "Pop"
            DDeOutfits[2] = "rope bunny"
            DDeOutfits[3] = "tir pony"
            DDeOutfits[4] = "roped off"
        endIf
    else
        UseDDe = false
    endIf

    Util.LogInfo("DDe Outfit Length: " + DDeOutfits.Length)

EndFunction

Bool Function HasKeys(Actor akVictim)
    int i = 0
    while i < KeyKeywords.Length
        if akVictim.GetItemCount(KeyKeywords[i])
            return true
        endIf
        i += 1
    endWhile
    return false
EndFunction

Bool Function IsWearingRestraints(Actor akVictim)
    if !DDPresent 
        return false
    endIf

    return akVictim.IsInFaction(BindTypeFaction)
EndFunction

Function TrackRestraints(Actor akVictim)
    if akVictim.IsInFaction(TrackedFaction)
        return
    endIf
    akVictim.AddToFaction(TrackedFaction)

    if !DDPresent
        return
    endIf

    int bindType = -1
    bool hasLegRestraints = false

    bool wriArmbinder = false
    int i = 0
    while i < WriArmbinderKeywords.Length
        if akVictim.WornHasKeyWord(WriArmbinderKeywords[i])
            bindType = 0
            i = WriArmbinderKeywords.Length
        endIf
        i += 1
    endWhile

    if bindType < 0
        i = 0
        while i < YokeKeywords.Length
            if akVictim.WornHasKeyWord(YokeKeywords[i])
                bindType = 1
                i = YokeKeywords.Length
            endIf
            i += 1
        endWhile
    endIf

    i = 0
    while i < LegCuffsKeywords.Length
        if akVictim.WornHasKeyWord(LegCuffsKeywords[i])
            hasLegRestraints = true
            i = LegCuffsKeywords.Length
        endIf
        i += 1
    endWhile

    Util.LogInfo("Tracking " + akVictim + " Bindtype = " + bindType + " Leg = " + hasLegRestraints)

    if bindType >= 0
        akVictim.AddToFaction(BindTypeFaction)
        akVictim.SetFactionRank(BindTypeFaction, bindType)
    endIf
    if hasLegRestraints
        akVictim.AddToFaction(LegRestraintsFaction)
    endIf
EndFunction

Function UntrackRestraints(Actor akVictim)
    akVictim.RemoveFromFaction(TrackedFaction)
    akVictim.RemoveFromFaction(BindTypeFaction)
    akVictim.RemoveFromFaction(LegRestraintsFaction)
EndFunction

Bool Function CanEquipRestraints()
    return DDPresent
EndFunction

Function EquipRestraints(Actor akVictim)
    if (MaleFollowerRestraintsEnabled && Util.GetGender(akVictim) == 0) || (FemaleFollowerRestraintsEnabled && Util.GetGender(akVictim) == 1) || akVictim == Game.GetPlayer()
        if UseDDe
            int i = 0
            int numOutfits = 0
            while i < DDeOutfits.Length
                if DDeOutfits[i] == ""
                    numOutfits = i
                    i = DDeOutfits.Length
                endIf
                i += 1
            endWhile

            if numOutfits > 0
                String otft = DDeOutfits[Utility.RandomInt(0, numOutfits - 1)]
                Util.LogInfo("Equipping DDe outfit " + otft + " on " + akVictim)
                if otft != ""
                    akVictim.SendModEvent("iDDeEquipOutfit", otft, 66)
                endIf

                return
            endIf
        endIf

        EquipRestraintOfType(akVictim, ArmRestraintsChance, ArmRestraints)
        EquipRestraintOfType(akVictim, LegRestraintsChance, LegRestraints)
        EquipRestraintOfType(akVictim, APlugsChance, APlugs)
        EquipRestraintOfType(akVictim, VPlugsChance, VPlugs)
        EquipRestraintOfType(akVictim, CollarsChance, Collars)
        EquipRestraintOfType(akVictim, MiscChance, Misc)

        if !EquipRestraintOfType(akVictim, HoodsChance, Hoods)
            EquipRestraintOfType(akVictim, GagsChance, Gags)
            EquipRestraintOfType(akVictim, BlindfoldsChance, Blindfolds)
        endIf
    endIf
EndFunction

Bool Function EquipRestraintOfType(Actor akVictim, float chance, Form[] restraintsArr)
    if Utility.RandomFloat(0, 1.0) <= chance
        Armor restraint = restraintsArr[Utility.RandomInt(0, restraintsArr.Length - 1)] as Armor
        Util.LogInfo("Equipping " + restraint + " on " + akVictim + " from list " + restraintsArr)
        bool equipped = (DD_Quest as zadLibs).LockDevice(akVictim, restraint)

        Utility.Wait(1.0)

        return equipped
    endIf
    return false
EndFunction

Function RestrainActor(Actor akVictim, bool playAnim = false)
    if akVictim == PlayerRef
        Game.SetPlayerAIDriven(true)
    else
        akVictim.SetRestrained(true)
    endIf
    Util.LogInfo("Restraining " + akVictim)
       
    int bindType = akVictim.GetFactionRank(BindTypeFaction)
    bool hasLegRestraints = akVictim.IsInFaction(LegRestraintsFaction)

    if bindType < 0
        akVictim.EquipItem(Cuffs, true, true)
    endIf
    if !hasLegRestraints
        akVictim.EquipItem(Fetters, true, true)
    endIf

    if playAnim
        if bindType < 0
            bindType = 0
        endIf

        int index = Utility.RandomInt(0, 3)
        if bindType == 0
            Debug.SendAnimationEvent(akVictim, ArmWriHogtiePoses[index])
        else
            Debug.SendAnimationEvent(akVictim, YokeHogtiePoses[index])
        endIf
    endIf
EndFunction

Function PlayWoundedIdle(Actor akTarget)
    int bindType = akTarget.GetFactionRank(BindTypeFaction)
    if bindType < 0
        Debug.SendAnimationEvent(akTarget, "IdleWounded_02")
    elseIf bindType == 0
        Debug.SendAnimationEvent(akTarget, ArmWriHogtiePoses[Utility.RandomInt(0, ArmWriHogtiePoses.Length - 1)])
    else
        Debug.SendAnimationEvent(akTarget, YokeWoundedPoses[Utility.RandomInt(0, YokeWoundedPoses.Length - 1)])
    endIf
EndFunction

Function UnrestrainActor(Actor akVictim)
    Util.LogInfo("Unrestraining " + akVictim)

    akVictim.UnequipItem(Cuffs, false, true)
    akVictim.UnequipItem(Fetters, false, true)
    akVictim.RemoveItem(Cuffs, 1, true)
    akVictim.RemoveItem(Fetters, 1, true)
    Debug.SendAnimationEvent(akVictim, "IdleForceDefaultState")
    if akVictim == PlayerRef
        Game.SetPlayerAIDriven(false)
    else
        akVictim.SetRestrained(false)
    endIf
EndFunction

Function AddKeys(Actor akAggressor, bool restraints, bool piercings = false, bool chastity = false)
    if Keys && Keys.Length > 0
        if restraints
            akAggressor.AddItem(Keys[0])
        endIf
        if piercings
            akAggressor.AddItem(Keys[1])
        endIf
        if chastity
            akAggressor.AddItem(Keys[2])
        endIf
    endIf
EndFunction

Function TamperWithRestraints(Actor akTarget)
    int i = 0

    while i < DDSlots.Length
        Armor x = akTarget.GetWornForm(DDSlots[i]) As Armor 
        if x && x.HasKeyword(LockableKeyword)
            if Utility.RandomFloat(0, 1.0) <= TightenChance
                (DD_Quest as zadLibs).TightenDevice(akTarget, x)
            endIf
        endIf
        i += 1
    endWhile
EndFunction

