Scriptname PD_SDPlus extends PD_EventTemplate

Scene Property SDScene Auto
Actor Property PlayerRef Auto

ReferenceAlias Property MasterAlias Auto

Actor Master

Bool Enslaved = false

Bool Function IsValid()
    return Game.GetModByName("sanguinesDebauchery.esp") != 255
EndFunction

Bool Function CanSelectRelease(Actor[] victims, int male, int female)
    if StorageUtil.GetIntValue(PlayerRef, "_SD_iEnslaved") > 0
        return false
    endIf

    int iGenderRestrictions = StorageUtil.GetIntValue(PlayerRef, "_SD_iGenderRestrictions")
    int playerGender = Util.GetGender(PlayerRef)

    if iGenderRestrictions == 0 && (male > 0 || female > 0)
        return true
    endIf

    if iGenderRestrictions == 1 && ((playerGender == 0 && male > 0) || (playerGender == 1 && female > 0))
        return true
    endIf

    if iGenderRestrictions == 1 && ((playerGender == 0 && male > 0) || (playerGender == 1 && female > 0))
        return true
    endIf

    return false
EndFunction

Actor[] Function Select(int victimIndex, Actor[] victims, Actor[] aggressors)
    int i = 0

    int iGenderRestrictions = StorageUtil.GetIntValue(PlayerRef, "_SD_iGenderRestrictions")
    int playerGender = Util.GetGender(PlayerRef)

    Actor[] Masters = PapyrusUtil.ActorArray(1)

    while i < aggressors.length
        Actor aggressor = aggressors[i]

        if (iGenderRestrictions == 0) || (iGenderRestrictions == 1 && (playerGender == Util.GetGender(aggressor))) || (iGenderRestrictions == 2 && (playerGender != Util.GetGender(aggressor)))
            Master = aggressor
            Masters[0] = Master
        endIf

        i += 1
    endWhile
    Util.LogInfo("Selected master " + Master)

    return Masters
EndFunction

Bool Function Start()
    Util.LogInfo("Starting SD Plus Outcome")
    MasterAlias.ForceRefTo(Master)
    Utility.Wait(1.0)
    Util.LogInfo("Starting SD Plus Scene")
    SDScene.Start()
    return true
EndFunction

Function EnslavePlayer()
    Util.LogInfo("Enslaving player by " + Master)
    Enslaved = false
    RegisterForModEvent("SDEnslavedStart", "OnPlayerEnslavement")
    Master.SendModEvent("PCSubEnslave") 
    MasterAlias.Clear()

    int i = 0
    while i < 10
        Util.LogInfo("Waiting 2 secs for enslavement")
        Utility.Wait(2.0)
        if StorageUtil.GetIntValue(PlayerRef, "_SD_iEnslaved") > 0 && Enslaved
            Util.LogInfo("Successfully enslaved, stopping loop")
            i = 30
        endIf
        i += 1
    endWhile

    Util.LogInfo("Finishing SD Plus Event")
    FinishEvent()    
EndFunction

Event OnPlayerEnslavement(string eventName, string strArg, float numArg, Form sender)
    Util.LogInfo("Player was enslaved")
    Enslaved = true
endEvent

