Scriptname PD_SexEvent extends PD_EventTemplate  

PD_DefeatHandler Property DH Auto
SexLabFramework Property SL Auto
Actor[] sexVics
Actor[] sexAggs
Int[] tids

int index = 0
int activeScenes = 0
int maxThreads = 12

Function OnModuleInit()
    sexVics = PapyrusUtil.ActorArray(maxThreads)
    sexAggs = PapyrusUtil.ActorArray(maxThreads)
    tids = PapyrusUtil.IntArray(maxThreads)
EndFunction

Bool Function Select(int victimsLeft, int aggressorsLeft, int startVictimIndex, int startAggressorIndex, Actor[] victims, Actor[] aggressors)
    if !(victimsLeft > 0 && aggressorsLeft > 0 && index < maxThreads)
        return false
    endIf

    Util.LogInfo("Prepping scene between " + victims[startVictimIndex] + " and " + aggressors[startAggressorIndex])
    sexVics[index] = victims[startVictimIndex]
    sexAggs[index] = aggressors[startAggressorIndex]
    index += 1

    return true
EndFunction

Bool Function Start()
    if index > 0
        index -= 1

        Util.LogInfo("Starting scene between " + sexVics[index] + " and " + sexAggs[index], 2)

        string hookName = "PD_2PSexScene" + index
        sslThreadController thread = SL.QuickStart(sexVics[index], sexAggs[index], none, none, none, sexVics[index], hookName, "Aggressive")
        tids[thread.tid] = index
        if thread
            RegisterForModEvent("HookAnimationEnd_" + hookName, "OnSexSceneEnded")
            activeScenes += 1
        endIf
        
        return thread != none
    else
        return false
    endIf
EndFunction

Function Reset()
    index = 0
    activeScenes = 0
    sexVics = PapyrusUtil.ActorArray(maxThreads)
    sexAggs = PapyrusUtil.ActorArray(maxThreads)
    tids = PapyrusUtil.IntArray(maxThreads)
EndFunction

Event OnSexSceneEnded(int tid, bool HasPlayer)
    activeScenes -= 1

    Util.LogInfo("Scene terminated - " + tid, 2)

    DH.RestrainActor(sexVics[tids[tid]], true)

    if activeScenes == 0
        Util.LogInfo("All scenes complete, terminating")
        FinishEvent()
    endIf
EndEvent 